package fr.doap.jdb.impl;

import fr.doap.jdb.utils.*;
import fr.doap.slog.*;

import java.lang.reflect.*;
import java.util.*;

abstract
public class PropGetterSetter {
	
	abstract public Class<?> getType();
	
	abstract public Object get(Object aObject);
	
	abstract public void set(Object aObject, Object aValue);
	
	static public class FieldGS extends PropGetterSetter {
		
		public FieldGS(Field aF) { mField=aF; }
		
		public Class<?> getType() { return mField.getType(); }
		
		public Object get(Object aObject) { try { return mField.get(aObject); } catch (Exception aE) { L.t(aE); } return null; }

		public void set(Object aObject, Object aValue) { try { mField.set(aObject, aValue); } catch (Exception aE) { L.t(aE); }}
		
		Field mField;
	}
	
	
	static public class CollectionGS extends PropGetterSetter {

		public Class<?> getType() { return byte[].class; }
		
		public Object get(Object aObject) {
			Iterator<Object> lIt = ((Collection<Object>)aObject).iterator();
			return null;
		}


		public void set(Object aObject, Object aValue) {
		
		}
	}
}